<?php

require_once("NTLMSoapClient.php");
require_once("ExchangeServices.base.php");

/**
 * Implementation class of ExchangeServices.
 *
 * You may modify this class for custom logic additions/methode overrides.
 * If you do so, don't forget to call the overriden super-class method!
 *
 * This stub was generated using WSDLInterpreter on Fri, 20 Jan 2012 09:12:40 +0100
 *
 * @see ExchangeServicesBase
 */
class ExchangeServices extends ExchangeServicesBase
{
    /**
     * Constructor for the ExchangeServices class
     * 
     * @param string $server
     * @param string $username
     * @param string $password
     * @param string $version one of the EWS_RequestServerVersion::VERSION_* constants
     */
    public function __construct($server = null, $username = null,
        $password = null, $version = EWS_RequestServerVersion::Version_Exchange2013) {
        $wsdl = dirname(__FILE__).'/wsdl/services.wsdl';
        $options = array(
            'user' => $username,
            'password' => $password,
            'version' => $version,
            'location' => 'https://'.$server.'/EWS/Exchange.asmx',
            );
        $options = ExchangeServicesBase::getClassMapOptions($options);
        $soapClient = new NTLMSoapClient($wsdl, $options, $server, $username, $password); // end return
        parent::__construct($wsdl, $soapClient);
    } // end function __construct()
}

/**
 * class ExchangeServicesServerImpl is an abstract base class
 * which defines the needed function to implement the SendNotfication
 * method, which is called by the Microsoft Exchange Server
 *
 */
abstract class ExchangeServicesServerImpl {
    var $soapServer;
    
    public function ExchangeServicesServerImpl($soapServer) {
        $this->soapServer = $soapServer;
    }
    
    abstract public function SendNotification(EWS_SendNotificationResponseType $result);
}

/**
 * class ExchangeServicesServer implements a SoapServer
 * for use with Push Subscriptions on the Microsoft Exchange Server
 * 2010 SP1
 *
 */
class ExchangeServicesServer 
{
    var $server;
    /**
     * This is method __construct
     *
     * @param mixed $implClassName This is the class name of the class, which implements the abstract class ExchangeServicesServerImpl
     *
     */    
    public function __construct($implClassName) {
        $options = array();
        $options["encoding"] = "UTF-8";
        //$options["cache_wsdl"] = WSDL_CACHE_NONE;
        $options = ExchangeServicesBase::getClassMapOptions($options);
        $wsdl = dirname(__FILE__).'/wsdl/NotificationService.wsdl';
        $this->server = new SoapServer($wsdl, $options);
        $this->server->setClass($implClassName, $this);
    }
    
    public function handle($postData = null) {
        $this->server->handle($postData);
    }
}
?>